TanStack

Solid Example: Debounce

import { createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { debounce } from '@tanstack/solid-pacer/debouncer'

function App1() {
  // Use your state management library of choice
  const [instantCount, setInstantCount] = createSignal(0)
  const [debouncedCount, setDebouncedCount] = createSignal(0)

  // Create debounced setter function - Stable reference required!
  const debouncedSetCount = debounce(setDebouncedCount, {
    wait: 500,
    // leading: true, // optional, defaults to false
  })

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      debouncedSetCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount()}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{debouncedCount()}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [searchText, setSearchText] = createSignal('')
  const [debouncedSearchText, setDebouncedSearchText] = createSignal('')

  // Create debounced setter function - Stable reference required!
  const debouncedSetSearch = debounce(setDebouncedSearchText, {
    wait: 500,
  })

  function handleSearchChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = target.value
    setSearchText(newValue)
    debouncedSetSearch(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 2</h1>
      <div>
        <input
          autofocus
          type="search"
          value={searchText()}
          onInput={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{searchText()}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{debouncedSearchText()}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [currentValue, setCurrentValue] = createSignal(50)
  const [debouncedValue, setDebouncedValue] = createSignal(50)

  // Create debounced setter function - Stable reference required!
  const debouncedSetValue = debounce(setDebouncedValue, {
    wait: 250,
  })

  function handleRangeChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = parseInt(target.value, 10)
    setCurrentValue(newValue)
    debouncedSetValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 3</h1>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue()}
            onInput={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue()}</span>
        </label>
      </div>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Debounced Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={debouncedValue()}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{debouncedValue()}</span>
        </label>
      </div>
      <div style={{ color: '#666', 'font-size': '0.9em' }}>
        <p>Debounced with 250ms wait time</p>
      </div>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
      <hr />
      <App2 />
      <hr />
      <App3 />
    </div>
  ),
  document.getElementById('root')!,
)

TanStack

Svelte Example: Debounce

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { debounce } from '@tanstack/svelte-pacer/debouncer'

  let instantCount = $state(0)

  let debouncedCount = $state(0)

  // Create debounced setter function - Stable reference required!
  const debouncedSetCount = debounce(
    (value: typeof debouncedCount) => (debouncedCount = value),
    {
      wait: 500,
      // leading: true, // optional, defaults to false
    },
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    instantCount = ((c) => {
      const newInstantCount = c + 1 // common new value for both
      debouncedSetCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })(instantCount)
  }

  let instantValue = $state(50)

  let debouncedValue = $state(50)

  // Create debounced setter function - Stable reference required!
  const debouncedSetValue = debounce(
    (value: typeof debouncedValue) => (debouncedValue = value),
    {
      wait: 250,
    },
  )

  function handleRangeChange(e: Event) {
    const newValue = parseInt((e.target as HTMLInputElement).value, 10)
    instantValue = newValue
    debouncedSetValue(newValue)
  }

  let searchText = $state('')

  let debouncedSearchText = $state('')

  // Create debounced setter function - Stable reference required!
  const debouncedSetSearch = debounce(
    (value: typeof debouncedSearchText) => (debouncedSearchText = value),
    {
      wait: 500,
    },
  )

  function handleSearchChange(e: Event) {
    const newValue = (e.target as HTMLInputElement).value
    searchText = newValue
    debouncedSetSearch(newValue)
  }
</script>

<div>
  <div>
    <h1>TanStack Pacer debounce Example 1</h1>
    <table>
      <tbody
        ><tr><td>Instant Count:</td><td>{instantCount}</td></tr><tr
          ><td>Debounced Count:</td><td>{debouncedCount}</td></tr
        ></tbody
      >
    </table>
    <div><button onclick={increment}>Increment</button></div>
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer debounce Example 2</h1>
    <div>
      <input
        type="search"
        value={searchText}
        oninput={handleSearchChange}
        placeholder="Type to search..."
        style="width: 100%"
      />
    </div>
    <table>
      <tbody
        ><tr><td>Instant Search:</td><td>{searchText}</td></tr><tr
          ><td>Debounced Search:</td><td>{debouncedSearchText}</td></tr
        ></tbody
      >
    </table>
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer debounce Example 3</h1>
    <div style="margin-bottom: 20px">
      <label
        >Instant Range:<input
          type="range"
          min="0"
          max="100"
          value={instantValue}
          oninput={handleRangeChange}
          style="width: 100%"
        /><span>{instantValue}</span></label
      >
    </div>
    <div>
      <label
        >Debounced Range (Readonly):<input
          type="range"
          min="0"
          max="100"
          value={debouncedValue}
          disabled
          style="width: 100%"
        /><span>{debouncedValue}</span></label
      >
    </div>
  </div>
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}

TanStack

Vue Example: Debounce

<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { pacerDevtoolsPlugin } from '@tanstack/vue-pacer-devtools'
import { ref } from 'vue'
import { debounce } from '@tanstack/vue-pacer/debouncer'

const dev = import.meta.env.DEV
const plugins = [pacerDevtoolsPlugin()]

const instantCount = ref(0)

const debouncedCount = ref(0)

// Create debounced setter function - Stable reference required!
const debouncedSetCount = debounce(
  (value: typeof debouncedCount.value) => (debouncedCount.value = value),
  {
    wait: 500,
    // leading: true, // optional, defaults to false
  },
)

function increment() {
  // this pattern helps avoid common bugs with stale closures and state
  instantCount.value = ((c) => {
    const newInstantCount = c + 1 // common new value for both
    debouncedSetCount(newInstantCount) // debounced state update
    return newInstantCount // instant state update
  })(instantCount.value)
}

const searchText = ref('')

const debouncedSearchText = ref('')

// Create debounced setter function - Stable reference required!
const debouncedSetSearch = debounce(
  (value: typeof debouncedSearchText.value) =>
    (debouncedSearchText.value = value),
  {
    wait: 500,
  },
)

function handleSearchChange(e: Event) {
  const newValue = (e.target as HTMLInputElement).value
  searchText.value = newValue
  debouncedSetSearch(newValue)
}

const instantValue = ref(50)

const debouncedValue = ref(50)

// Create debounced setter function - Stable reference required!
const debouncedSetValue = debounce(
  (value: typeof debouncedValue.value) => (debouncedValue.value = value),
  {
    wait: 250,
  },
)

function handleRangeChange(e: Event) {
  const newValue = parseInt((e.target as HTMLInputElement).value, 10)
  instantValue.value = newValue
  debouncedSetValue(newValue)
}
</script>

<template>
  <div>
    <div>
      <h1>TanStack Pacer debounce Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{{ instantCount }}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{{ debouncedCount }}</td>
          </tr>
        </tbody>
      </table>
      <div><button @click="increment">Increment</button></div>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer debounce Example 2</h1>
      <div>
        <input
          type="search"
          :value="searchText"
          @input="handleSearchChange"
          placeholder="Type to search..."
          :style="{ width: '100%' }"
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{{ searchText }}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{{ debouncedSearchText }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer debounce Example 3</h1>
      <div :style="{ marginBottom: '20px' }">
        <label
          >Instant Range:<input
            type="range"
            min="0"
            max="100"
            :value="instantValue"
            @input="handleRangeChange"
            :style="{ width: '100%' }"
          /><span>{{ instantValue }}</span></label
        >
      </div>
      <div>
        <label
          >Debounced Range (Readonly):<input
            type="range"
            min="0"
            max="100"
            :value="debouncedValue"
            disabled
            :style="{ width: '100%' }"
          /><span>{{ debouncedValue }}</span></label
        >
      </div>
    </div>
  </div>
  <TanStackDevtools v-if="dev" :plugins="plugins" />
</template>

Docs
Cloudflare
CodeRabbit
Railway
OpenRouter
WorkOS
SerpAPI
AG Grid
Clerk
Netlify
Sentry
Electric
Prisma
Unkey
Cloudflare
CodeRabbit
Railway
OpenRouter
WorkOS
SerpAPI
AG Grid
Clerk
Netlify
Sentry
Electric
Prisma
Unkey
Debouncer API Reference
Throttler API Reference
Rate Limiter API Reference
Queue API Reference
Batcher API Reference

React Example: Debounce

import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { debounce } from '@tanstack/react-pacer/debouncer'

function App1() {
  // Use your state management library of choice
  const [instantCount, setInstantCount] = useState(0)
  const [debouncedCount, setDebouncedCount] = useState(0)

  // Create debounced setter function - Stable reference required!
  const debouncedSetCount = useCallback(
    debounce(setDebouncedCount, {
      wait: 500,
      // leading: true, // optional, defaults to false
    }),
    [], // must be memoized to avoid re-creating the debouncer on every render (consider using useDebouncer instead in react)
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      debouncedSetCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{debouncedCount}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [searchText, setSearchText] = useState('')
  const [debouncedSearchText, setDebouncedSearchText] = useState('')

  // Create debounced setter function - Stable reference required!
  const debouncedSetSearch = useCallback(
    debounce(setDebouncedSearchText, {
      wait: 500,
    }),
    [],
  )

  function handleSearchChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = e.target.value
    setSearchText(newValue)
    debouncedSetSearch(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={searchText}
          onChange={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{searchText}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{debouncedSearchText}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [instantValue, setInstantValue] = useState(50)
  const [debouncedValue, setDebouncedValue] = useState(50)

  // Create debounced setter function - Stable reference required!
  const debouncedSetValue = useCallback(
    debounce(setDebouncedValue, {
      wait: 250,
    }),
    [],
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setInstantValue(newValue)
    debouncedSetValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Instant Range:
          <input
            type="range"
            min="0"
            max="100"
            value={instantValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{instantValue}</span>
        </label>
      </div>
      <div>
        <label>
          Debounced Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={debouncedValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{debouncedValue}</span>
        </label>
      </div>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
  </div>,
)
import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { debounce } from '@tanstack/react-pacer/debouncer'

function App1() {
  // Use your state management library of choice
  const [instantCount, setInstantCount] = useState(0)
  const [debouncedCount, setDebouncedCount] = useState(0)

  // Create debounced setter function - Stable reference required!
  const debouncedSetCount = useCallback(
    debounce(setDebouncedCount, {
      wait: 500,
      // leading: true, // optional, defaults to false
    }),
    [], // must be memoized to avoid re-creating the debouncer on every render (consider using useDebouncer instead in react)
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      debouncedSetCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{debouncedCount}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [searchText, setSearchText] = useState('')
  const [debouncedSearchText, setDebouncedSearchText] = useState('')

  // Create debounced setter function - Stable reference required!
  const debouncedSetSearch = useCallback(
    debounce(setDebouncedSearchText, {
      wait: 500,
    }),
    [],
  )

  function handleSearchChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = e.target.value
    setSearchText(newValue)
    debouncedSetSearch(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={searchText}
          onChange={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{searchText}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{debouncedSearchText}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [instantValue, setInstantValue] = useState(50)
  const [debouncedValue, setDebouncedValue] = useState(50)

  // Create debounced setter function - Stable reference required!
  const debouncedSetValue = useCallback(
    debounce(setDebouncedValue, {
      wait: 250,
    }),
    [],
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setInstantValue(newValue)
    debouncedSetValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer debounce Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Instant Range:
          <input
            type="range"
            min="0"
            max="100"
            value={instantValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{instantValue}</span>
        </label>
      </div>
      <div>
        <label>
          Debounced Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={debouncedValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{debouncedValue}</span>
        </label>
      </div>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
  </div>,
)